/*
 * Nessus Development Header
 *
 * It is better to include this file than trying to include <string.h>,
 * because this file may be called strings.h in some UNIX implementations.
 * This header also provides macros for strchr, strrchr, memcpy and memmove
 * for older Sys V systems.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#else
#error Needs config.h... First run ./configure!
#endif

#if HAVE_UNISTD_H
#include <sys/types.h>
#include <unistd.h>
#endif

#if STDC_HEADERS
#include <string.h>
#else
#ifndef HAVE_STRCHR
#define strchr index
#define strrchr rindex
#endif
char *strchr (), *strrchr ();
#ifndef HAVE_MEMCPY
#define memcpy(d, s, n) bcopy ((s), (d), (n))
#define memmove(d, s, n) bcopy ((s), (d), (n))
#endif
#endif

#if HAVE_BZERO == 0
#define bzero(s,z) memset(s,0,z)
#endif
