/* Hostloop -- the Hostloop Library
 * Copyright (C) 1998 Renaud Deraison
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */   
 
#ifndef __HLS_PARSER_H__
#define __HLS_PARSER_H__

struct parses_t
	{
	char * name;
	short category; 
	struct parses_t * next;
	};
	
#define p_NOTHING 0	/*      nothing					*/
#define p_DONT_TEST 2	/*	n:hostname				*/
#define p_DO_TEST 4	/*	y:hostname -- bypasses DONT_TEST	*/
#define p_DONT_DNS 8    /*	d:hostname				*/
#define p_DONT_SM 16	/*	s:hostname				*/

/*

#define pTEST(a) (!((a) & p_DONT_TEST) || ((a) & p_DO_TEST))
#define pDNS(a)  (!((a) & p_DONT_DNS))
#define pSM(a)	 (!((a) & p_DONT_SM))

*/

#define pTEST(a) 1
#define pDNS(a) 1
#define pSM(a) 1
	
#endif
