/* Nessus
 * Copyright (C) 1998 Renaud Deraison
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This is the Authentification Manager
 *
 * This authentification scheme is BADLY written, and should NOT
 * be used in the future
 */


#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdlib.h>
#include <stdio.h> 
#include <stdarg.h>
#include <fcntl.h>
#ifdef HAVE_STRING_H
#include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */
#include <sys/types.h>
#include <sys/socket.h> 
#include <signal.h>

#include "comm.h"
#include "auth.h"
#include "sighand.h"

int auth_login(user,password)
	char * user;
	char * password;
{
  char * buf;
  buf = emalloc(40);
  
  auth_gets(buf, 8);
  if(strncmp(buf, "User : ", strlen(buf)))return(-1);
  auth_printf("%s\n", user);
  
  bzero(buf, 40);
  auth_gets(buf,12);
  if(strncmp(buf, "Password : ", strlen(buf)))return(-1);
  auth_printf("%s\n", password);
  efree(buf);
  return(0);
}


void auth_printf(char * data, ...)
{
  va_list param;
  
  signal(SIGPIPE, sighand_pipe);
  va_start(param, data);
  vfprintf(stdout, data, param);
  fflush(stdout);
  signal(SIGPIPE, SIG_IGN);
}                    

char * auth_gets(s, size)
	char * s;
	size_t size;
{
  signal(SIGALRM, sighand_alarm);
  alarm(SERVER_TIMEOUT); 
  fgets(s, size, stdin);
  /* we will have to decrypt some stuff here !*/
  signal(SIGALRM, SIG_IGN);
  alarm(0);
  return(s);
}
