/* Nessuslib -- the Nessus Library
 * Copyright (C) 1998 Renaud Deraison
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#include <config.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#ifdef HAVE_STRING_H
#include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */ 
 
void * emalloc(unsigned long size)
{
    void * ptr;
	
    ptr = malloc(size);
    if(!ptr){
	fprintf(stderr, "Could not allocate a pointer !\n");
	exit(1);
	}
    bzero(ptr, size);
    return(ptr);
}

void efree(void * ptr)
{
    if(ptr)free(ptr);
}


size_t estrlen(const char *s, size_t n) {
    size_t  i;

    for(i = 0; (*(s+i) != '\0' && i < n); i++);

        return i;
}
