#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>   
#define NAME "ftp real path"
#define DESC "This plugin attempts to determine the real path to \
the ftp home -- this can be of some use for system intruders"
#define COPYRIGHT "no copyright"
#define SUMM "attempts to get the real path to the remote ftp home"





int plugin_init(struct arglist *desc);
int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_GATHER_INFO);
	plug_set_family(desc, "FTP");
	return(0);
}
	

int plugin_run(struct arglist * args);	
int plugin_run(struct arglist * args)
{
	int soc;
	char * buf;
	
	
	if(host_get_port_state(args, 21)<=0)return(0);
	soc = open_sock_tcp(args, 21);
	if(soc<0)return(-1);
	buf = emalloc(65000);
	
	recv(soc, buf, 4,0);
	recv(soc, buf+4, 4095,0);
	bzero(buf, 4095);
	
	sprintf(buf, "USER ftp\n");
	send(soc, buf, strlen(buf),0);
	
	bzero(buf,4095);
	recv(soc, buf, 4,0);
	recv(soc, buf+4,4090,0);
	
	sprintf(buf, "PASS joe@\n");
	send(soc, buf, strlen(buf), 0);
	recv(soc, buf, 4,0);
	recv(soc, buf+4,65000,0);
	
	if(strstr(buf, "230"))
	{
	 bzero(buf, 65000);
	 sprintf(buf, "CWD\n");
	 send(soc, buf, strlen(buf),0);
	 bzero(buf, 4095);
	 recv(soc, buf, 4,0);
	 recv(soc, buf+4, 4095,0);
	 if(!strstr(buf," /:"))
	 {
	  char * data;
	  char *t;
	  data = emalloc(strlen(buf)+255);
	  t = strchr(buf+4, ':');
	  if(t)t[0]=0;
	  sprintf(data,"The remote ftp home is '%s'
This information may interest some system hackers who know
where to put a .rhost file, although this problem is not
very serious...
Solution : modify the sources of your ftp daemon", buf+4);
	  if(t)t[0]=':';
	  post_info(args, 21, data);
	  efree(data);
	 } 	
       }
        efree(buf);
        close(soc);
	return(0);
}

