#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>   
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#define NAME "X11 checker"
#define DESC "Determines whether X11 is sniffable"
#define COPYRIGHT "no copyright"
#define SUMM "determines whether X11 is sniffable remotely"







int plugin_init(struct arglist *desc);
int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_GATHER_INFO);
	plug_set_family(desc, "Misc.");
	return(0);
}
	

int plugin_run(struct arglist * args);	
int plugin_run(struct arglist * args)
{
	Display * dpy;
	char * host;
	
	if(host_get_port_state(args, 6000)<=0)
		{
		return(0);
		}
	host = emalloc(strlen(plug_get_hostname(args))+3);
	sprintf(host, "%s:0", plug_get_hostname(args));
	if((dpy = XOpenDisplay(host)))
		{
		XCloseDisplay(dpy);
		post_hole(args, 6000, "XWindow may be sniffed");
		}
	efree(host);
	return 0;
	
}

