#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>   
#define NAME "Windows NT ftp 'guest' account"
#define DESC "This plugin determines whether the 'guest' account \
of a remote WindowsNT box has been disabled"
#define COPYRIGHT "no copyright"
#define SUMM "checks if there's a 'guest' account on the remote WindowsNT ftp server"





int plugin_init(struct arglist *desc);
int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_GATHER_INFO);
	plug_set_family(desc, "FTP");
	return(0);
}
	

int plugin_run(struct arglist * args);	
int plugin_run(struct arglist * args)
{
	int soc;
	char * buf;
	
	
	if(host_get_port_state(args, 21)<=0)return(0);
	soc = open_sock_tcp(args, 21);
	if(soc<0)return(-1);
	buf = emalloc(4096);
	
	recv(soc, buf, 4,0);
        recv(soc, buf+4, 4095,0);    
        
	sprintf(buf, "USER guest\n");
	send(soc, buf, strlen(buf),0);
	recv(soc, buf, 4,0);
        recv(soc, buf+4, 4095,0);   
        
        sprintf(buf, "PASS guest\n");
        send(soc, buf, strlen(buf),0);
	recv(soc, buf, 4,0);
	if(strstr(buf, "230"))
	{
	 post_hole(args, 21, 
"The remote host has a 'guest' account set up for ftp, and it's
usually not a good thing...");	
       }
        efree(buf);
        close(soc);
	return(0);
}

